import sys

""" 
If nobody ever calls this method, the math.sqrt function
will never be imported/loaded. After the first call, it is
imported/loaded forever
"""
def SQUARE_ROOT(x):
    global imported_sqrt
    try:
        print("\tAttempting to call math.sqrt...")
        result = imported_sqrt(x)
        print("\tCalled math.sqrt successfully!")
        return result
    except NameError as e:
        print("\tFailed to call math.sqrt!")
        print("\tDynamically loading the code of math.sqrt...")
        from math import sqrt as imported_sqrt
        return SQUARE_ROOT(x)
    pass

"""
Main function
"""
if __name__ == "__main__":
    import sys
    try:
    	a = float(sys.argv[1])
    except IndexError:
	    print(f"Usage: {sys.argv[0]} <a positive floating point number>")
	    sys.exit(1)

    print("Calling SQUARE_ROOT for the first time")
    SQUARE_ROOT(a)
    print("Calling SQUARE_ROOT a second time")
    SQUARE_ROOT(a)
